#ifndef _MY_DS3231_H
#define _MY_DS3231_H

#include "esp_types.h"
#include "i2cdev.h"

#include "time.h"

typedef struct rtc_params_t
{

    uint8_t SDAPin;
    uint8_t SCLPin;
    uint8_t sda_pullup_en;
    uint8_t scl_pullup_en;
    uint8_t device_addr;

} rtc_params_t;

static uint8_t dec2Bcd(uint8_t val);
static uint8_t bcd2Dec(uint8_t val);


int initRTC(i2c_dev_t *RTCStruct);

int getRawRTCTime(i2c_dev_t *RTCStruct, void* Output[]);
int setRawRTCTime(i2c_dev_t *RTCStruct, void* Input[]);

int getRTCTime(i2c_dev_t *RTCStruct, struct tm *TimeO);
int setRTCTime(i2c_dev_t *RTCStruct, struct tm *TimeI);
int setRTCClock(i2c_dev_t *RTCStruct, uint8_t Sec, uint8_t Minute, uint8_t Hour, uint8_t Day,
                uint8_t Date, uint8_t Month, uint8_t Year);


#endif