#ifndef _BUTTON_H
#define _BUTTON_H

#include "stdio.h"

#define FILTER_DELAY 50 // Filter delay in Milli seconds

typedef struct btn_params_t
{

    uint8_t BtnPin;
    uint8_t BtnActiveState;
    uint8_t BtnPinPullUp;
    uint8_t BtnPinPullDown;
    int64_t DBT;
    int64_t CurrTime;
    uint8_t AF; // Active flag
    uint8_t LS; // Last state
    uint8_t CS; // Current state 
    void (*PressedISR)(void *args);
    void (*ReleasedISR)(void *args);
    void *arg;
    void *args[];

} btn_params_t;

typedef struct btns_params_t
{
    uint8_t ISRIdx;
    uint8_t BtnActiveState;
    uint8_t BtnPinPullUp;
    uint8_t BtnPinPullDown;
    void (*PressedISR)();
    void (*ReleasedISR[2])();
    uint8_t BtnsPins[2];


} btns_params_t;


// typedef enum
// {
//     MODULE_FOO_ONE,
//     MODULE_FOO_TWO,
//     MODULE_FOO_THREE
// } module_foo_t;

uint8_t initButton(btn_params_t *BtnParams);
uint8_t initButtons(btn_params_t** BtnsParams, uint8_t ButtonCount);

void startButtons();

void attachReleased(btn_params_t *BtnParams, void (*BtnISR)(void *args), void *arg);
void attachReleased_s(btns_params_t *BtnsParams, uint8_t BtnPin, void (*BtnISR)());

void attachPressed(btn_params_t *BtnParams, void (*BtnISR)(void *args), void *arg);
void attachDoublePressed(btn_params_t *BtnParams, void (*BtnISR)(void *args), void *arg);
void attachDoubleHold(btn_params_t *BtnParams, void (*BtnISR)(void *args), void *arg);

void attachDoubleClick(btn_params_t *BtnParams, void (*BtnISR)(void *args), void *arg, uint32_t TimeOut);
#endif