
void toggleTimer() {

  uint64_t CTimer;
  timer_config_t TimerConf;

  timer_get_counter_value(TIMER_GROUP_0, TIMER_0, &CTimer);
  timer_get_config(TIMER_GROUP_0, TIMER_0, &TimerConf);
  // if timer is enabled disable else enable(start)
  if (TimerConf.counter_en) {

    timer_pause(TIMER_GROUP_0, TIMER_0);
    esp_timer_stop(DispTimerHandle);
    // PauseTimePoint += CTimer - RefTimePoint;
    // RefTimePoint = CTimer;

    printf("Stopping the timer, %lld\n", CTimer);
  }

  else {
    timer_start(TIMER_GROUP_0, TIMER_0);
    esp_timer_start_periodic(DispTimerHandle, 100000);
    // RefTimePoint = CTimer;
    TimerStatus = 1;
    printf("Starting the timer, %lld\n", CTimer);
  }
  xQueueSend(TimerTickQ, &CTimer, pdMS_TO_TICKS(1000));
}

void recordTimer() {

  // static int64_t CurrTimerTime;

  // CurrTimerTime = (esp_timer_get_time() - RefTimePoint) + PauseTimePoint;
  // xSemaphoreTake(CurrTimerTimeS, 1000/portTICK_PERIOD_MS);
  timer_get_counter_value(TIMER_GROUP_0, TIMER_0, &RecordedTimes[TimerIndex].RecordTime);
  // xSemaphoreGive(CurrTimerTimeS);

  RecordedTimes[TimerIndex].SinceBootTime = esp_timer_get_time();
  time(&RecordedTimes[TimerIndex].RTCTime);

  TimerIndex++;
  xQueueSend(TimerRecordQ, &RecordedTimes[TimerIndex], pdMS_TO_TICKS(1000));

  printf("Recorded Times\n");

  // ESP_ERROR_CHECK(nvs_open_from_partition("Myrecords", "TRecords", NVS_READWRITE, &NVSHandle));

  // char IdxStr[14];
  // // itoa(TimerIndex, IdxStr, 10);
  // IdxStr[0] = (48 + TimerIndex);
  // IdxStr[1] = NULL;
  // nvs_set_blob(NVSHandle, IdxStr, (void *)&RecordedTimes[TimerIndex], sizeof(timer_record_t));
  // ESP_ERROR_CHECK(nvs_commit(NVSHandle));
  // nvs_close(NVSHandle);
}

void resetTimer() {

  static uint64_t CurrTimerUs;

  // RefTimePoint = esp_timer_get_time();
  // PauseTimePoint = 0;
  timer_set_counter_value(TIMER_GROUP_0, TIMER_0, 0);
  timer_get_counter_value(TIMER_GROUP_0, TIMER_0, &CurrTimerUs);
  // xSemaphoreTake(CurrTimerTimeS, 1000/portTICK_PERIOD_MS);
  // CurrTimerTime = 0;
  // CurrTimerUs = RefTimePoint + PauseTimePoint;
  xQueueSend(TimerTickQ, &CurrTimerTime, pdMS_TO_TICKS(1000));
  // xSemaphoreGive(CurrTimerTimeS);

  printf("Timer Reset!\n");
}

void upCursor() {
}
void midCursor() {
}
void downCursor() {
}


void buzzer_tone(float Freq) {

  ledc_timer_config_t timer = {
      .speed_mode = GPIO_OUTPUT_SPEED,
      .duty_resolution = LEDC_TIMER_10_BIT,
      .timer_num = LEDC_TIMER_0,
      .freq_hz = Freq,
      .clk_cfg = LEDC_AUTO_CLK};

  ledc_timer_config(&timer);

  // ledc_set_duty_and_update(GPIO_OUTPUT_SPEED, LEDC_CHANNEL_0, 512, 0);
  ledc_set_freq(GPIO_OUTPUT_SPEED, LEDC_CHANNEL_0, Freq);
  ledc_set_duty(GPIO_OUTPUT_SPEED, LEDC_CHANNEL_0, 512); // 12% duty - play here for your speaker or buzzer
  ledc_update_duty(GPIO_OUTPUT_SPEED, LEDC_CHANNEL_0);
}

void buzzer_stop() {

  ledc_set_duty(GPIO_OUTPUT_SPEED, LEDC_CHANNEL_0, 0);
  ledc_update_duty(GPIO_OUTPUT_SPEED, LEDC_CHANNEL_0);
}

void buzzer_beep(uint BeepCount, float Freq, int OnPeriod, uint OffPeriod) {

  for (uint8_t C = 0; C < BeepCount; C++) {

    buzzer_tone(Freq);
    vTaskDelay(OnPeriod / portTICK_PERIOD_MS);
    buzzer_stop();
    vTaskDelay(OffPeriod / portTICK_PERIOD_MS);
  }
}
